/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package cz.fel.k333.wparest.client;

import com.sun.jersey.api.client.Client;
import com.sun.jersey.api.client.ClientResponse;
import com.sun.jersey.api.client.WebResource;
import com.sun.jersey.api.client.config.ClientConfig;
import com.sun.jersey.api.client.config.DefaultClientConfig;
import com.sun.jersey.api.json.JSONConfiguration;
import cz.fel.k333.wparest.Person;
import javax.ws.rs.core.MediaType;

/**
 *
 * @author zdenekkouba
 */
public class ClientNew {
    
    public static void main(String[] args) {

        ClientConfig clientConfig = new DefaultClientConfig();
        clientConfig.getFeatures().put(JSONConfiguration.FEATURE_POJO_MAPPING, Boolean.TRUE);

        Client client = Client.create(clientConfig);
//        WebResource resource = client.resource("http://localhost:8080/WPARest/rest/person/new");
        // WebResource resource = client.resource(
        //        "http://localhost:8080/WPARest/rest/person/named/Pavel/Nemec");
        WebResource resource = client.resource(
                "http://localhost:8080/JerseyTest/rest/person/namedParams?gName=Pavel&fName=Nemec");
        ClientResponse response =
                resource.accept("application/json").get(ClientResponse.class);
        int statusCode = response.getStatus();
        System.out.println("StatusCode=" + statusCode);
        if (statusCode >= 300) {
            return;
        }
        Person person = response.getEntity(Person.class);
        System.out.println("Given name: " + person.getGivenName());
        System.out.println("Family name: " + person.getFamilyName());
        System.out.println();
        System.out.println("******** RENAMING *************");
        System.out.println();
        
        resource = client.resource(
                "http://localhost:8080/JerseyTest/rest/person/namedParams?gName=Jiri&fName=Prejmenovany");
        /*
         * response = resource.type(MediaType.APPLICATION_JSON).accept("application/json").get(ClientResponse.class);
        System.out.println("StatusCode=" + statusCode);
        if (statusCode >= 300) {
            return;
        }
        person = response.getEntity(Person.class);
        */
        person = resource.type(MediaType.APPLICATION_JSON).accept("application/json").get(Person.class);

        System.out.println("Given name: " + person.getGivenName());
        System.out.println("Family name: " + person.getFamilyName());
        System.out.println();
    }
    
}
