/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package cz.fel.k333.wparest.rest;

import cz.fel.k333.wparest.Person;
import javax.ws.rs.Consumes;
import javax.ws.rs.GET;
import javax.ws.rs.POST;
import javax.ws.rs.Path;
import javax.ws.rs.PathParam;
import javax.ws.rs.Produces;
import javax.ws.rs.QueryParam;
import javax.ws.rs.core.MediaType;

/**
 *
 * @author zdenekkouba
 */
@Path("/person")
public class PersonREST {
    
    @GET
    @Path("/new")
    @Produces(MediaType.APPLICATION_JSON)
    public Person newPerson() {
        Person person = new Person();
        person.setGivenName("Jan");
        person.setFamilyName("Novak");
        return person;
    }
    
    @GET
    @Path("/named/{gName}/{fName}")
    @Produces(MediaType.APPLICATION_JSON)
    public Person namedPerson( @PathParam("gName") String givenName,
                              @PathParam("fName") String familyName) {
        Person person = new Person();
        person.setGivenName(givenName);
        person.setFamilyName(familyName);
        return person;
    }

    @GET
    @Path("/namedParams")
    @Produces(MediaType.APPLICATION_JSON)
    public Person paramPerson( @QueryParam("gName") String givenName,
                              @QueryParam("fName") String familyName) {
        Person person = new Person();
        person.setGivenName(givenName);
        person.setFamilyName(familyName);
        return person;
    }
    
    @POST
    @Path("/rename")
    @Consumes(MediaType.APPLICATION_JSON)
    @Produces(MediaType.APPLICATION_JSON)
    public Person paramPerson( @QueryParam("gName") String givenName,
                              @QueryParam("fName") String familyName,
                              Person person) {
        person.setGivenName(givenName);
        person.setFamilyName(familyName);
        return person;
    }
    
}
